diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/grid.py ns-3.41/utils/grid.py
--- ns-3.40/utils/grid.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/grid.py	2024-02-09 14:44:08.629795300 -0800
@@ -1562,6 +1699,7 @@
         @return none
         """
         self.__render.set_smaller_zoom()
+
     def __set_bigger_cb(self, widget):
         """! Set Bigger Callback
         @param self this object
@@ -1569,18 +1707,21 @@
         @return none
         """
         self.__render.set_bigger_zoom()
+
     def __output_png_cb(self, widget):
         """! Output PNG Callback
         @param self this object
         @param widget widget
         @return none
         """
-        dialog = gtk.FileChooserDialog("Output Png", self.__window,
-                                       gtk.FILE_CHOOSER_ACTION_SAVE, ("Save", 1))
+        dialog = gtk.FileChooserDialog(
+            "Output Png", self.__window, gtk.FILE_CHOOSER_ACTION_SAVE, ("Save", 1)
+        )
         self.__dialog = dialog
         dialog.set_default_response(1)
         dialog.connect("response", self.__dialog_response_cb)
         dialog.show()
+
     def __dialog_response_cb(self, widget, response):
         """! Dialog Response Callback
         @param self this object
@@ -1598,12 +1739,12 @@
 def read_data(filename):
     timelines = Timelines()
     colors = Colors()
-    m1 = re.compile('range ([^ ]+) ([^ ]+) ([^ ]+) ([0-9]+) ([0-9]+)')
-    m2 = re.compile('event-str ([^ ]+) ([^ ]+) ([^ ]+) ([0-9]+)')
-    m3 = re.compile('event-int ([^ ]+) ([^ ]+) ([0-9]+) ([0-9]+)')
-    m4 = re.compile('color ([^ ]+) #([a-fA-F0-9]{2,2})([a-fA-F0-9]{2,2})([a-fA-F0-9]{2,2})')
+    m1 = re.compile("range ([^ ]+) ([^ ]+) ([^ ]+) ([0-9]+) ([0-9]+)")
+    m2 = re.compile("event-str ([^ ]+) ([^ ]+) ([^ ]+) ([0-9]+)")
+    m3 = re.compile("event-int ([^ ]+) ([^ ]+) ([0-9]+) ([0-9]+)")
+    m4 = re.compile("color ([^ ]+) #([a-fA-F0-9]{2,2})([a-fA-F0-9]{2,2})([a-fA-F0-9]{2,2})")
 
-    with open(filename, encoding='utf-8') as fh:
+    with open(filename, encoding="utf-8") as fh:
         for line in fh.readlines():
             m = m1.match(line)
             if m:
@@ -1658,8 +1799,7 @@
     range_colors = []
     for range_value in range_values:
         range_colors.append(colors.lookup(range_value))
-    top_legend.set_legends(range_values,
-                           range_colors)
+    top_legend.set_legends(range_values, range_colors)
     graphic.set_top_legend(top_legend)
     data = TimelinesRenderer()
     data.set_timelines(timelines, colors)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/python-unit-tests.py ns-3.41/utils/python-unit-tests.py
--- ns-3.40/utils/python-unit-tests.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/python-unit-tests.py	2024-02-09 14:44:08.629795300 -0800
@@ -19,7 +19,15 @@
 # Author: Gustavo J. A. M. Carneiro <gjc@inescporto.pt>
 
 import unittest
-from ns import ns
+
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 import sys
 
 UINT32_MAX = 0xFFFFFFFF
@@ -53,12 +61,14 @@
         ns.Simulator.Destroy()
         self._args_received = None
         self._cb_time = None
-        ns.cppyy.cppdef("""
+        ns.cppyy.cppdef(
+            """
             EventImpl* pythonMakeEvent(void (*f)(std::vector<std::string>), std::vector<std::string> l)
             {
                 return MakeEvent(f, l);
             }
-        """)
+        """
+        )
         event = ns.cppyy.gbl.pythonMakeEvent(callback, sys.argv)
         ns.Simulator.ScheduleNow(event)
         ns.Simulator.Run()
@@ -82,12 +92,14 @@
         ns.Simulator.Destroy()
         self._args_received = None
         self._cb_time = None
-        ns.cppyy.cppdef("""
+        ns.cppyy.cppdef(
+            """
             EventImpl* pythonMakeEvent2(void (*f)(std::vector<std::string>), std::vector<std::string> l)
             {
                 return MakeEvent(f, l);
             }
-        """)
+        """
+        )
         event = ns.cppyy.gbl.pythonMakeEvent2(callback, sys.argv)
         ns.Simulator.Schedule(ns.Seconds(123), event)
         ns.Simulator.Run()
@@ -113,12 +125,14 @@
         self._cb_time = None
         ns.cppyy.cppdef("void null(){ return; }")
         ns.Simulator.Schedule(ns.Seconds(123), ns.cppyy.gbl.null)
-        ns.cppyy.cppdef("""
+        ns.cppyy.cppdef(
+            """
             EventImpl* pythonMakeEvent3(void (*f)(std::vector<std::string>), std::vector<std::string> l)
             {
                 return MakeEvent(f, l);
             }
-        """)
+        """
+        )
         event = ns.cppyy.gbl.pythonMakeEvent3(callback, sys.argv)
         ns.Simulator.ScheduleDestroy(event)
         ns.Simulator.Run()
@@ -146,12 +160,14 @@
         self._args_received = None
         self._cb_time = None
         self._context_received = None
-        ns.cppyy.cppdef("""
+        ns.cppyy.cppdef(
+            """
             EventImpl* pythonMakeEvent4(void (*f)(uint32_t, std::vector<std::string>), uint32_t context, std::vector<std::string> l)
             {
                 return MakeEvent(f, context, l);
             }
-        """)
+        """
+        )
         event = ns.cppyy.gbl.pythonMakeEvent4(callback, 54321, sys.argv)
         ns.Simulator.ScheduleWithContext(54321, ns.Seconds(123), event)
         ns.Simulator.Run()
@@ -203,20 +219,29 @@
         def python_rx_callback(socket) -> None:
             self._received_packet = socket.Recv(maxSize=UINT32_MAX, flags=0)
 
-        ns.cppyy.cppdef("""
+        ns.cppyy.cppdef(
+            """
             Callback<void,ns3::Ptr<ns3::Socket> > make_rx_callback_test_socket(void(*func)(Ptr<Socket>))
             {
                 return MakeCallback(func);
             }
-        """)
+        """
+        )
 
-        sink = ns.network.Socket.CreateSocket(node, ns.core.TypeId.LookupByName("ns3::UdpSocketFactory"))
+        sink = ns.network.Socket.CreateSocket(
+            node, ns.core.TypeId.LookupByName("ns3::UdpSocketFactory")
+        )
         sink.Bind(ns.network.InetSocketAddress(ns.network.Ipv4Address.GetAny(), 80).ConvertTo())
         sink.SetRecvCallback(ns.cppyy.gbl.make_rx_callback_test_socket(python_rx_callback))
 
-        source = ns.network.Socket.CreateSocket(node, ns.core.TypeId.LookupByName("ns3::UdpSocketFactory"))
-        source.SendTo(ns.network.Packet(19), 0,
-                      ns.network.InetSocketAddress(ns.network.Ipv4Address("127.0.0.1"), 80).ConvertTo())
+        source = ns.network.Socket.CreateSocket(
+            node, ns.core.TypeId.LookupByName("ns3::UdpSocketFactory")
+        )
+        source.SendTo(
+            ns.network.Packet(19),
+            0,
+            ns.network.InetSocketAddress(ns.network.Ipv4Address("127.0.0.1"), 80).ConvertTo(),
+        )
 
         ns.Simulator.Run()
         self.assertTrue(self._received_packet is not None)
@@ -290,7 +315,7 @@
         @param self this object
         @return None
         """
-        from ctypes import c_bool, c_int, c_double, c_char_p, create_string_buffer
+        from ctypes import c_bool, c_char_p, c_double, c_int, create_string_buffer
 
         test1 = c_bool(True)
         test2 = c_int(42)
@@ -355,12 +380,12 @@
         stack.Install(nodes)
 
         address = ns.internet.Ipv4AddressHelper()
-        address.SetBase(ns.network.Ipv4Address("10.1.1.0"),
-                        ns.network.Ipv4Mask("255.255.255.0"))
+        address.SetBase(ns.network.Ipv4Address("10.1.1.0"), ns.network.Ipv4Mask("255.255.255.0"))
 
         interfaces = address.Assign(devices)
 
-        ns.cppyy.cppdef("""
+        ns.cppyy.cppdef(
+            """
             namespace ns3
             {
                 Callback<void,Ptr<Socket> > make_rx_callback(void(*func)(Ptr<Socket>))
@@ -372,7 +397,8 @@
                     return MakeEvent(f, socket, packet, address);
                 }
             }
-        """)
+        """
+        )
 
         ## EchoServer application class
         class EchoServer(ns.applications.Application):
@@ -388,13 +414,19 @@
                 return None
                 """
                 super().__init__()
+                ## __python_owns__ flag indicates that Cppyy should not manage the lifetime of this variable
                 self.__python_owns__ = False  # Let C++ destroy this on Simulator::Destroy
                 ## Listen port for the server
                 self.port = port
                 ## Socket used by the server to listen to port
-                self.m_socket = ns.network.Socket.CreateSocket(node,
-                                                               ns.core.TypeId.LookupByName("ns3::UdpSocketFactory"))
-                self.m_socket.Bind(ns.network.InetSocketAddress(ns.network.Ipv4Address.GetAny(), self.port).ConvertTo())
+                self.m_socket = ns.network.Socket.CreateSocket(
+                    node, ns.core.TypeId.LookupByName("ns3::UdpSocketFactory")
+                )
+                self.m_socket.Bind(
+                    ns.network.InetSocketAddress(
+                        ns.network.Ipv4Address.GetAny(), self.port
+                    ).ConvertTo()
+                )
                 self.m_socket.SetRecvCallback(ns.make_rx_callback(EchoServer._Receive))
                 EchoServer.socketToInstanceDict[self.m_socket] = self
 
@@ -415,13 +447,16 @@
                 self.m_socket.SendTo(packet, 0, address)
                 if EchoServer.LOGGING:
                     inetAddress = ns.InetSocketAddress.ConvertFrom(address)
-                    print("At time +{s}s server sent {b} bytes from {ip} port {port}"
-                          .format(s=ns.Simulator.Now().GetSeconds(),
-                                  b=packet.__deref__().GetSize(),
-                                  ip=inetAddress.GetIpv4(),
-                                  port=inetAddress.GetPort()),
-                          file=sys.stderr,
-                          flush=True)
+                    print(
+                        "At time +{s}s server sent {b} bytes from {ip} port {port}".format(
+                            s=ns.Simulator.Now().GetSeconds(),
+                            b=packet.__deref__().GetSize(),
+                            ip=inetAddress.GetIpv4(),
+                            port=inetAddress.GetPort(),
+                        ),
+                        file=sys.stderr,
+                        flush=True,
+                    )
 
             def Receive(self):
                 """! Function to receive a packet from an address
@@ -432,13 +467,16 @@
                 packet = self.m_socket.RecvFrom(address)
                 if EchoServer.LOGGING:
                     inetAddress = ns.InetSocketAddress.ConvertFrom(address)
-                    print("At time +{s}s server received {b} bytes from {ip} port {port}"
-                          .format(s=ns.Simulator.Now().GetSeconds(),
-                                  b=packet.__deref__().GetSize(),
-                                  ip=inetAddress.GetIpv4(),
-                                  port=inetAddress.GetPort()),
-                          file=sys.stderr,
-                          flush=True)
+                    print(
+                        "At time +{s}s server received {b} bytes from {ip} port {port}".format(
+                            s=ns.Simulator.Now().GetSeconds(),
+                            b=packet.__deref__().GetSize(),
+                            ip=inetAddress.GetIpv4(),
+                            port=inetAddress.GetPort(),
+                        ),
+                        file=sys.stderr,
+                        flush=True,
+                    )
                 event = ns.pythonMakeEventSend(EchoServer._Send, self.m_socket, packet, address)
                 ns.Simulator.Schedule(ns.Seconds(1), event)
 
@@ -486,5 +524,5 @@
         ns.Simulator.Destroy()
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main(verbosity=1, failfast=True)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/tests/TestBase.py ns-3.41/utils/tests/TestBase.py
--- ns-3.40/utils/tests/TestBase.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/tests/TestBase.py	2024-02-09 14:44:08.629795300 -0800
@@ -17,42 +17,52 @@
 #
 
 from __future__ import print_function
-import sys
-import subprocess
+
 import argparse
 import os
+import subprocess
+import sys
+
 
 def print_case_in_file(case_string, out):
     for i in range(100):
-        print("-", end='', file=out)
+        print("-", end="", file=out)
     print(file=out)
-    print("running test case " + case_string, end='\n\n', file=out)
+    print("running test case " + case_string, end="\n\n", file=out)
     out.flush()
 
+
 def print_failed_cases(failed_cases):
     print("\nFailed Cases:")
     for case in failed_cases:
         print(case)
 
+
 def print_cmds(cmds):
-    print('Commands to be executed:')
+    print("Commands to be executed:")
     for cmd in cmds:
-        print(cmd.replace(sys.executable, ''))
+        print(cmd.replace(sys.executable, ""))
+
 
 def set_workdir():
-    dir_files = [f for f in os.listdir('.') if os.path.exists(f)]
-    if not 'VERSION' in dir_files and not 'ns3' in dir_files:
-        if os.path.split(os.path.abspath('.'))[1] == 'tests' and os.path.split(os.path.abspath(os.pardir))[1] == 'utils':
-            os.chdir('../../')
+    dir_files = [f for f in os.listdir(".") if os.path.exists(f)]
+    if not "VERSION" in dir_files and not "ns3" in dir_files:
+        if (
+            os.path.split(os.path.abspath("."))[1] == "tests"
+            and os.path.split(os.path.abspath(os.pardir))[1] == "utils"
+        ):
+            os.chdir("../../")
         else:
-            print('Error: Invalid working directory')
+            print("Error: Invalid working directory")
             sys.exit(1)
 
+
 ## TestBaseClass class
 class TestBaseClass:
     """
-        Generic class for testing tools based on provided commands and test cases.
+    Generic class for testing tools based on provided commands and test cases.
     """
+
     ## @var my_env
     #  os environment
     ## @var mode
@@ -72,9 +82,9 @@
         """
         self.my_env = os.environ
         set_workdir()
-        self.my_env['LD_LIBRARY_PATH'] = os.getcwd() + "/build"
+        self.my_env["LD_LIBRARY_PATH"] = os.getcwd() + "/build"
         self.mode = mode
-        self.outfile = 'test-port-'+self.mode+'.out'
+        self.outfile = "test-port-" + self.mode + ".out"
         self.options = self.parseargs(argv, desc)
 
     def parseargs(self, argv, desc):
@@ -86,15 +96,39 @@
         @return command line arguments
         """
         parser = argparse.ArgumentParser(description=desc)
-        parser.add_argument('-f', '--file', action='store', dest='out_file', default=self.outfile,
-                            metavar="FILE",
-                            help='File to be used for storing the command specific output (Default: '+self.outfile+')')
-        parser.add_argument('-c', action='store_true', dest='cmds', default=False,
-                            help='List out all the commands being tested')
-        parser.add_argument('-m', action='store_true', dest='mute', default=False,
-                            help='Sends only stderr output to FILE')
-        parser.add_argument('-x', '--customcmd', action='store', dest='custcmd', default=None,
-                            help='Enter a comma-separated list of commands to override the existing ones. NOT APPLICABLE FOR TEST-PY SUITE.')
+        parser.add_argument(
+            "-f",
+            "--file",
+            action="store",
+            dest="out_file",
+            default=self.outfile,
+            metavar="FILE",
+            help="File to be used for storing the command specific output (Default: "
+            + self.outfile
+            + ")",
+        )
+        parser.add_argument(
+            "-c",
+            action="store_true",
+            dest="cmds",
+            default=False,
+            help="List out all the commands being tested",
+        )
+        parser.add_argument(
+            "-m",
+            action="store_true",
+            dest="mute",
+            default=False,
+            help="Sends only stderr output to FILE",
+        )
+        parser.add_argument(
+            "-x",
+            "--customcmd",
+            action="store",
+            dest="custcmd",
+            default=None,
+            help="Enter a comma-separated list of commands to override the existing ones. NOT APPLICABLE FOR TEST-PY SUITE.",
+        )
         return parser.parse_args(argv)
 
     def override_cmds(self):
@@ -115,38 +149,39 @@
         if self.options.cmds:
             print_cmds(cmds)
             return
-        base_dir = os.sep.join(os.path.abspath(__file__).replace(os.path.pathsep, '/').split('/')[:-3])
+        base_dir = os.sep.join(
+            os.path.abspath(__file__).replace(os.path.pathsep, "/").split("/")[:-3]
+        )
         final_return = 0
         total_tests = len(cmds)
         passed = 0
         progress = 0.0
         failed_cases = []
-        with open(self.options.out_file, 'w', encoding='utf-8') as out:
+        with open(self.options.out_file, "w", encoding="utf-8") as out:
             outstream = out
-            with open(os.devnull, 'w', encoding='utf-8') as sink:
+            with open(os.devnull, "w", encoding="utf-8") as sink:
                 if self.options.mute:
                     outstream = sink
                 for cmd in cmds:
-                    case_string = cmd.replace(sys.executable, '')
+                    case_string = cmd.replace(sys.executable, "")
                     print("running test case: " + case_string)
                     print_case_in_file(case_string, out)
                     progress += 1
-                    ret = subprocess.call(cmd,
-                                          shell=True,
-                                          env=self.my_env,
-                                          stdout=outstream,
-                                          stderr=out,
-                                          cwd=base_dir
-                                          )
+                    ret = subprocess.call(
+                        cmd, shell=True, env=self.my_env, stdout=outstream, stderr=out, cwd=base_dir
+                    )
                     if not ret:
                         passed += 1
                     else:
                         final_return = 1
                         failed_cases.append(case_string)
-                    print("[ %s out of %s ] test cases passed; Progress = %.2f%% \n" % (passed, total_tests, progress*100/total_tests))
+                    print(
+                        "[ %s out of %s ] test cases passed; Progress = %.2f%% \n"
+                        % (passed, total_tests, progress * 100 / total_tests)
+                    )
         if final_return != 0:
             print_failed_cases(failed_cases)
         else:
             print("\nAll cases passed")
-        print("Detailed output available in " + self.options.out_file, end='\n\n')
+        print("Detailed output available in " + self.options.out_file, end="\n\n")
         return final_return
